Attribute VB_Name = "makeMonth"
'Written by Alan Macek <calendarmaker@alanmacek.com> - August 2000

'This program is release under the 'General Public License'
'See the text of the license in the License.txt file or at www.opensource.org

Option Explicit

'Creates a single Excel sheet containing a single month
Public Sub makeSingle(sheet As Excel.Worksheet, calDate As Date)
    On Error Resume Next
    With sheet
        .Name = Format(calDate, "mmmm")
        .Columns("a:g").ColumnWidth = 13.57
        .Rows("2:2").HorizontalAlignment = xlCenter
        .Range("A1").FormulaR1C1 = Format(calDate, "mmmm yyyy")
        .Range("A1").NumberFormat = "mmmm yyyy"
        .Range("A1", "G1").HorizontalAlignment = xlCenterAcrossSelection
        .Range("A2").FormulaR1C1 = "Sunday"
        .Range("B2").FormulaR1C1 = "Monday"
        .Range("C2").FormulaR1C1 = "Tuesday"
        .Range("D2").FormulaR1C1 = "Wednesday"
        .Range("E2").FormulaR1C1 = "Thursday"
        .Range("F2").FormulaR1C1 = "Friday"
        .Range("G2").FormulaR1C1 = "Saturday"
        
        Dim j As Integer
        Dim rowNo As Integer
        Dim colName As String
        rowNo = 3
        For j = 1 To Day(DateAdd("d", -1, DateAdd("m", 1, calDate)))
            colName = Chr(64 + WeekDay(DateAdd("d", j - 1, calDate)))
            If .Range(colName & rowNo).FormulaR1C1 <> "" Then
                .Range(colName & rowNo).FormulaR1C1 = .Range(colName & rowNo).FormulaR1C1 & " /" & Str(j)
            Else
                .Range(colName & rowNo).FormulaR1C1 = Str(j)
            End If
            If colName = "G" Then rowNo = rowNo + 1
            If rowNo = 8 Then rowNo = 7
        Next j
        'Alignment
        .Rows("3:7").HorizontalAlignment = xlRight
        'Height
        .Rows("3:7").RowHeight = 134.25
        .Rows("1:1").RowHeight = 25.5
        .Range("A1").Select
        With Selection.Font
            .Name = "Arial"
            .FontStyle = "Bold"
            .Size = 16
        End With
        
        'Borders
        With .Range("A2", "G" & rowNo)
            .Borders(xlRight).Weight = xlThin
            .Borders(xlLeft).Weight = xlThin
            .Borders(xlTop).Weight = xlThin
            .Borders(xlBottom).Weight = xlThin
        End With
        .Rows("2:2").Font.Bold = True
    End With
    'Page Setup
    With ActiveSheet.PageSetup
        .LeftMargin = Application.InchesToPoints(0.354330708661417)
        .RightMargin = Application.InchesToPoints(0.354330708661417)
        .TopMargin = Application.InchesToPoints(0.393700787401575)
        .BottomMargin = Application.InchesToPoints(0.393700787401575)
        .CenterHeader = ""
        .CenterFooter = ""
        .PrintGridlines = False
        .CenterHorizontally = True
        .CenterVertically = True
        .BlackAndWhite = True
    End With
End Sub
